## bornagain 21.1+ds3

=== CMakeLists.txt ===
###########################################################################
# top-level CMakeLists.txt for building BornAgain
############################################################################

### CMake configuration

cmake_minimum_required(VERSION 3.20 FATAL_ERROR)

set(CMAKE_MODULE_PATH
    ${CMAKE_SOURCE_DIR}/cmake
    ${CMAKE_SOURCE_DIR}/cmake/find
    ${CMAKE_SOURCE_DIR}/cmake/pack)
set(CONFIGURABLES_DIR ${CMAKE_SOURCE_DIR}/cmake/configurables)

include(BornAgain/Git)
message(STATUS "Git branch '${GIT_BRANCH}' at commit ${GIT_COMMIT}, tag: '${GIT_TAG}'")

include(commons/PreventInSourceBuilds)


### Project settings

project(BornAgain
    VERSION 21.1
    DESCRIPTION "BornAgain: simulate and fit reflectometry and grazing-incidence scattering."
    HOMEPAGE_URL https://www.bornagainproject.org
    LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 20)


### Options

# options that are on by default (switch off for accelerated builds of limited scope)
option(BORNAGAIN_PYTHON "Build with Python support" ON)
option(BA_GUI "Build a graphical user interface" ON)
option(BA_TIFF_SUPPORT "Tiff files read/write support" ON)
option(BA_TESTS "Build tests" ON)

# options that are off by default (switch on for additional functionality)
option(CONFIGURE_BINDINGS "Generate python bindings during build (requires swig)" OFF)
option(CONFIGURE_EXAMPLES "Configure examples (requires ruby)" OFF)
option(CONFIGURE_DOXY "Configure Doxygen files" OFF)
option(ALLCONFIG "Regenerate Py wrappers, examples, Doxyfiles" OFF)
option(ZERO_TOLERANCE "Terminate compilation on warnings" OFF)
option(DEVELOPER_CHECKS "Checks required from developers but not from external users" OFF)
option(DEV "Development: turns ALLCONFIG, ZERO_TOLERANCE, DEVELOPER_CHECKS on" OFF)
option(BA_COVERAGE "Build with test coverage information" OFF)
option(BA_DEBUG_OPTIMIZATION "Build with debug optimization (gcc only)" OFF)
option(BA_TIDY "Invokes clang-tidy" OFF)
option(BATCH_MODE "Suppress some output" OFF)
option(ALGORITHM_DIAGNOSTIC "Let some algorithms set diagnostic variables" OFF)
option(BA_PY_PACKAGE "Build a Python wheel with the default Python platform, or a given Python platform (via BA_PY_PLATFORM)" OFF)
option(BUILD_DEBIAN "Build a debian package" OFF)
option(BA_APPLE_BUNDLE "Create a MacOS bundle" OFF)
option(BA_CPP_API "Install header files" OFF)

# options that set other options
set(BA_PY_PLATFORM "" CACHE INTERNAL "Path to Python platform to build a Python package")
string(STRIP "${BA_PY_PLATFORM}" BA_PY_PLATFORM)
if(BA_PY_PLATFORM)
    set(BA_PY_PACKAGE ON)
endif()

if(DEV)
    set(ALLCONFIG ON)
    set(ZERO_TOLERANCE ON)
    set(DEVELOPER_CHECKS ON)
endif()
if(ALLCONFIG)
    set(CONFIGURE_BINDINGS ON)
    set(CONFIGURE_EXAMPLES ON)
    set(CONFIGURE_DOXY ON)
endif()
if(BATCH_MODE)
    set(BA_GUI OFF)
endif()

# check compatibility of options

if(BA_TIDY AND BORNAGAIN_PYTHON)
    message(FATAL_ERROR "BA_TIDY is incompatible with BORNAGAIN_PYTHON")
endif()

if(BA_GUI AND NOT BORNAGAIN_PYTHON AND NOT BA_TIDY)
    message(FATAL_ERROR "BA_GUI without BORNAGAIN_PYTHON is currently unsupported"
        " (except with BA_TIDY)")
endif()

### Generator type (Release|Debug)

# Show info about generator type; set CMAKE_BUILD_TYPE if not given
if(CMAKE_CONFIGURATION_TYPES)
    message(STATUS "Generator type: Multi-configuration generator")
else()
    message(STATUS "Generator type: Single-configuration generator")
endif()
message("    CMAKE_CONFIGURATION_TYPES: ${CMAKE_CONFIGURATION_TYPES}")
# The following is not correct/does not have any effect for multi-configuration generators.
# But when correcting this, be aware that CMAKE_BUILD_TYPE is used in more scripts!
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING "" FORCE)
    message("    CMAKE_BUILD_TYPE type not given - forced to 'Release'")
else()
    string(TOUPPER "${CMAKE_BUILD_TYPE}" _upper_build_type)
    set(BUILD_${_upper_build_type} 1)
endif()
message("    CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")
configure_file("${PROJECT_SOURCE_DIR}/cmake/configurables/config_build.h.in"
    "${PROJECT_BINARY_DIR}/inc/config_build.h"
    @ONLY)


### Configure tests

if(BA_TESTS)
    # GoogleTest: `gtest_discover_tests` discovers tests by asking the _compiled test executable_
    # to enumerate its tests. `PRE_TEST` delays test discovery until just prior to test execution;
    # this avoids calling the executables during the build phase.
    set(CMAKE_GTEST_DISCOVER_TESTS_DISCOVERY_MODE PRE_TEST)

    include(CTest) # equivalent to "enable_testing() ???
    add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} -LE Fullcheck)
       # => 'make check' is an alias for 'ctest'
    add_custom_target(fullcheck COMMAND ${CMAKE_CTEST_COMMAND})
       # => 'make check' is an alias for 'ctest'
   endif()


### Operating system

# introduce `LINUX` flag (along with `APPLE` and `WIN32`)
if(UNIX AND CMAKE_SYSTEM_NAME MATCHES Linux)
    set(LINUX ON)
endif()

# the host system must be Linux, Apple or Windows
if(NOT (LINUX OR APPLE OR WIN32))
    message(FATAL_ERROR "Operating system ${CMAKE_SYSTEM_NAME} is not supported")
endif()


### Further configuration
# list of original core libraries needed to build the MacOS package
set(BornAgain_LIBRARIES "" CACHE INTERNAL "BornAgain libraries")

# function definitions
include(commons/GetFilenameComponent) # fct get_filename_component (overwrites CMake's built-in)
include(BornAgain/SwigLib) # fct SwigLib
include(BornAgain/MakeLib) # fct MakeLib

# main settings
include(BornAgain/Directories)
include(BornAgain/Dependences)

if(WIN32)
    include(BornAgain/InstallDll)
endif()

# Python
if(BORNAGAIN_PYTHON OR BA_PY_PACKAGE)
    include(multipython/PyDependences)
endif()

if(BORNAGAIN_PYTHON)
    include(BornAgain/PythonAPI)
endif()

if(BA_GUI)
    include(BornAgain/Qt)
    string(APPEND CMAKE_CXX_FLAGS " -DHAVE_QT=ON")
endif()

if(UNIX)
    if(LINUX)
        include(BornAgain/Linux)
    elseif(APPLE)
        include(BornAgain/MacOS)
    endif()
    include(BornAgain/NixInstall)
elseif(WIN32)
    include(BornAgain/Windows)
endif()

include(BornAgain/Config)

include(BornAgain/Compiler)
if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set(CLANG ON)
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(GCC ON)
    string(APPEND CMAKE_CXX_FLAGS " -fdiagnostics-color=always")
elseif(NOT WIN32)
    message(FATAL_ERROR "Unsupported compiler, id=${CMAKE_CXX_COMPILER_ID}")
endif()

if(ZERO_TOLERANCE)
    string(APPEND CMAKE_CXX_FLAGS " -Werror -Wfatal-errors")
endif()
if(ALGORITHM_DIAGNOSTIC)
    string(APPEND CMAKE_CXX_FLAGS " -DALGORITHM_DIAGNOSTIC=ON")
endif()
string(APPEND CMAKE_CXX_FLAGS_DEBUG " -DBA_DEBUG")

# debug optimization
if(BA_DEBUG_OPTIMIZATION)
  include(commons/DebugOptimization)
endif()


### Configure source components

# library Fit
add_subdirectory(Fit/3rdparty)
add_subdirectory(Fit)

# other components
set(CoreComponents "PyCore;Base;Param;Sample;Resample;Device;Sim")
set(AllComponents "${CoreComponents};Img3D;GUI")

# code analysis
include(BornAgain/LineLength)
include(BornAgain/Format)
if(BA_COVERAGE)
  include(commons/CoverageFunction)
  include(BornAgain/Coverage)
endif()

# third-party code
add_subdirectory(3rdparty/common)
add_subdirectory(3rdparty/Core)
if(BA_GUI)
    add_subdirectory(3rdparty/GUI/qcustomplot)
endif()

# from here on our own code, occasionally scrutinized by clang-tidy
if(BA_TIDY)
    set(CMAKE_CXX_CLANG_TIDY "clang-tidy") # has effect only if compiler is clang; uses .clang-tidy
endif()

# configure core component libraries
foreach(lib ${CoreComponents})
    add_subdirectory(${lib})
endforeach()
if(BORNAGAIN_PYTHON)
    add_dependencies(BornAgainFit swig_runtime)
    if (CONFIGURE_EXAMPLES)
        add_subdirectory(rawEx)
    endif()
endif()

# GUI
if(BA_GUI)
    add_subdirectory(Img3D)
    add_subdirectory(GUI)
    add_subdirectory(App)
endif()

# tests
if(BA_TESTS)
    add_subdirectory(Tests/Unit)
    if(BORNAGAIN_PYTHON)
        add_subdirectory(Tests/Examples)
        add_subdirectory(Tests/Py)
    endif()
    add_subdirectory(Tests/SimFactory)
    add_subdirectory(Tests/Functional)
    add_subdirectory(Tests/Suite)
endif()

# documentation
# TODO: 'hugo' depends on 'excopy' and 'figures' which are produced in Tests/Examples
# The tests and documentation should be decoupled.
if(BORNAGAIN_PYTHON AND BA_TESTS) # required for examples
    add_subdirectory(hugo)
endif()
add_subdirectory(Doc/man)
if(CONFIGURE_DOXY)
    add_subdirectory(Doc/Doxygen)
endif()


### Finalize

# after-install message
add_subdirectory(cmake)

# make package targets
include(BornAgain/Pack)

# build log
include(BornAgain/BuildLog)
install(FILES ${BA_BUILD_LOG} DESTINATION ${destination_share})
message(STATUS "BornAgain build log written to '${BA_BUILD_LOG}'")

message(STATUS "CMake done")

=== App/CMakeLists.txt ===
###############################################################################
# Builds BornAgain/GUI main executable
###############################################################################

if(WIN32)
    set(executable_name BornAgain)
else()
    set(executable_name bornagain)
endif()

set(source_files main.cpp AppOptions.cpp)

# -----------------------------------------------------------------------------
# Qt configuration
# -----------------------------------------------------------------------------
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)

# -----------------------------------------------------------------------------
# executable icons
# -----------------------------------------------------------------------------
if(WIN32)
    set(system_addons bornagain.rc)
    if(NOT win32_console)
        set(executable_options WIN32)
    endif()
endif()

if(APPLE)
    set(MACOSX_BUNDLE_ICON_FILE BornAgain.icns)
    set_source_files_properties(${CMAKE_CURRENT_SOURCE_DIR}/BornAgain.icns
        PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
    if(BA_APPLE_BUNDLE)
        set(executable_options MACOSX_BUNDLE)
    endif()
endif()

# -----------------------------------------------------------------------------
# executable
# -----------------------------------------------------------------------------
add_executable(${executable_name}
    ${executable_options}
    ${source_files}
    ${system_addons})

# -----------------------------------------------------------------------------
# dependencies
# -----------------------------------------------------------------------------
target_link_libraries(${executable_name} PRIVATE BornAgainGUI ${Boost_LIBRARIES})
target_include_directories(${executable_name} PRIVATE ${CMAKE_SOURCE_DIR})

# -----------------------------------------------------------------------------
# extra target properties
# -----------------------------------------------------------------------------
if(WIN32)
    set_target_properties(${executable_name} PROPERTIES LINK_FLAGS /ENTRY:mainCRTStartup)
    if(win32_console)
        set_target_properties(${executable_name} PROPERTIES COMPILE_DEFINITIONS _CONSOLE)
    endif()
endif()

if(LINUX)
    # Add proper RPATHs as hints to load the dependencies at run-time
    # NOTE: Unlike `RUNPATH`, `RPATH` is searched for transitive dependencies;
    # ie. paths in RPATH will be considered for everything that is
    # dynamically loaded, even dependencies of dependencies.
    # see <https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=847298>
    set(link_flags "-Wl,--disable-new-dtags,-rpath,\$ORIGIN:\$ORIGIN/../lib")
    set_target_properties(${executable_name} PROPERTIES LINK_FLAGS ${link_flags})
endif()

if(APPLE)
    set(MACOSX_BUNDLE_IDENTIFIER org.bornagainproject.BornAgain)
    configure_file(${CONFIGURABLES_DIR}/MacOSXBundleInfo.plist.in
        ${BUILD_VAR_DIR}/Info.plist @ONLY)

    set_target_properties(${executable_name}
        PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${BUILD_VAR_DIR}/Info.plist)

    if(BA_APPLE_BUNDLE)
        set(link_flags
            "-Wl,-rpath,@loader_path/../lib -Wl,-rpath,@loader_path/../Frameworks/ \
-Wl,-rpath,@loader_path/../lib/BornAgain-${BornAgain_VERSION_MAJOR}.${BornAgain_VERSION_MINOR}/")
    else()
        set(link_flags "-Wl,-rpath,\
@loader_path/../../../lib/BornAgain-${BornAgain_VERSION_MAJOR}.${BornAgain_VERSION_MINOR}/")
    endif()
    set_target_properties(${executable_name} PROPERTIES LINK_FLAGS ${link_flags})
endif()

# -----------------------------------------------------------------------------
# installation section
# -----------------------------------------------------------------------------
if(BA_APPLE_BUNDLE)
    install(TARGETS ${executable_name} BUNDLE DESTINATION "." COMPONENT Applications)
else()
    install(TARGETS ${executable_name} RUNTIME DESTINATION ${destination_bin}
        COMPONENT Applications)
endif()

set(image_files
    ${CMAKE_CURRENT_SOURCE_DIR}/BornAgain.ico
    ${CMAKE_CURRENT_SOURCE_DIR}/BornAgain.icns
    ${CMAKE_SOURCE_DIR}/GUI/images/BornAgain_48x48.png
    ${CMAKE_SOURCE_DIR}/GUI/images/BornAgain_64x64.png)
install(FILES ${image_files} DESTINATION ${destination_images} COMPONENT Applications)

# -----------------------------------------------------------------------------
# system dependent installation
# -----------------------------------------------------------------------------
if(BA_APPLE_BUNDLE)
    install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/BornAgain.icns
        DESTINATION ${destination_bundle}/Contents/Resources/)
    install(FILES ${CMAKE_SOURCE_DIR}/cmake/configurables/qt.conf.mac
        DESTINATION ${destination_bundle}/Contents/Resources/
        RENAME qt.conf)

    # adjust MacOS bundle
    get_property(exe_dir TARGET ${executable_name} PROPERTY RUNTIME_OUTPUT_DIRECTORY)
    set(MACPKG_MAIN_EXE "${exe_dir}/${executable_name}.app/Contents/MacOS/${executable_name}")

    # list of BornAgain core libraries
    set(MACPKG_CORE_LIBS "$CACHE{BornAgain_LIBRARIES}")

    # list of required Qt plugins (paths relative to Qt root dir)
    set(MACPKG_QT_PLUGINS_RELDIR "${QT6_INSTALL_PLUGINS}")
    set(MACPKG_QT_PLUGINS
        platforms/libqcocoa.dylib
        iconengines/libqsvgicon.dylib
        imageformats/libqjpeg.dylib
        imageformats/libqsvg.dylib
        styles/libqmacstyle.dylib
        )
    # Qt plugins directory in within the MacOS bundle
    set(MACPKG_QT_PLUGINS_DIR PlugIns)  # conform to settings in `qt.conf`
    # convert CMake list to space-separated lists
    set(MACPKG_EXTRA_LIBS "${BA_Dependencies}")

    configure_file("${CMAKE_SOURCE_DIR}/devtools/deploy/mac/mac_package.py.in"
        "${BUILD_VAR_DIR}/mac_package.py" @ONLY)

endif()

if(WIN32)
    message(STATUS "Configuring the GUI package")

    foreach(comp ${QtComponents})
        set(QtComp Qt6::${comp})
        get_target_property(dll ${QtComp} LOCATION_Release)
        get_property(dll TARGET ${QtComp} PROPERTY LOCATION_Release)
        install(FILES ${dll} DESTINATION ${destination_lib} COMPONENT Libraries)
        message(STATUS "Install Qt lib ${QtComp} (${dll})")
    endforeach()

    # extract Qt root-dir
    # 'C:/Qt/6.2.4/msvc2019_64/lib/cmake/Qt6' => 'C:/Qt/6.2.4/msvc2019_64'
    file(TO_CMAKE_PATH "${Qt_DIR}" qt_dir_str)

    install(FILES
    ${Qt_DIR}/bin/opengl32sw.dll
    DESTINATION ${destination_lib} COMPONENT Libraries)
    install(FILES
    ${Qt_PLUGINS_DIR}/platforms/qwindows.dll
    DESTINATION bin/platforms COMPONENT Libraries)
    install(FILES
    ${Qt_PLUGINS_DIR}/iconengines/qsvgicon.dll
    DESTINATION bin/iconengines COMPONENT Libraries)
    install(FILES
    ${Qt_PLUGINS_DIR}/imageformats/qjpeg.dll
    ${Qt_PLUGINS_DIR}/imageformats/qsvg.dll
    DESTINATION bin/imageformats COMPONENT Libraries)

    set(QT_VISTA_STYLE ${Qt_PLUGINS_DIR}/styles/qwindowsvistastyle.dll)
    if(EXISTS ${QT_VISTA_STYLE})
        install(FILES ${QT_VISTA_STYLE}
                DESTINATION bin/styles COMPONENT Libraries)
    else()
        message(AUTHOR_WARNING File ${QT_VISTA_STYLE} not found.)
    endif()
    unset(QT_VISTA_STYLE)

endif()

if(LINUX)
    set(LINUXPKG_MAIN_EXE "${CMAKE_BINARY_DIR}/bin/${executable_name}")
    set(LINUXPKG_FRAMEWORK_DEST "${destination_lib}")

    configure_file(
        ${CMAKE_SOURCE_DIR}/devtools/deploy/linux/adjust_pkg_linux.sh.in
        ${BUILD_VAR_DIR}/adjust_pkg_linux.sh @ONLY)
endif()

# execute package-fixing script before CPack builds the final package file
configure_file(
    ${CMAKE_SOURCE_DIR}/cmake/configurables/FixPack.cmake.in
    ${BUILD_VAR_DIR}/FixPack.cmake @ONLY)

install(SCRIPT ${BUILD_VAR_DIR}/FixPack.cmake)

=== Base/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainSim
############################################################################

set(component Base)
set(lib BornAgain${component})

# --- source and include files ---

file(GLOB source_files */*.cpp)
file(GLOB include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)

#--- define target properties ---
add_library(${lib} SHARED)
set_target_properties(${lib} PROPERTIES
    COMPONENT_NAME ${component}
    SWIG_TMP_DIR "${CMAKE_CURRENT_BINARY_DIR}/Wrap"
    SOURCE_FILES "${source_files}"
    INCLUDE_FILES "${include_files}"
    EMBED_PYTHON ${BORNAGAIN_PYTHON})

# --- make the library ---
MakeLib(${lib})

# --- external dependences ---

target_link_libraries(${lib}
    PUBLIC
    ${GSL_LIBRARIES}
    ${FFTW3_LIBRARIES}
)

target_include_directories(${lib}
    PUBLIC
    ${CMAKE_SOURCE_DIR}
    SYSTEM PUBLIC
    ${LibHeinz_INCLUDE_DIR}
    ${Boost_INCLUDE_DIRS}
    # the following needed for Mac and Win, even if they are implied under Linux
    ${GSL_INCLUDE_DIR}
    ${FFTW3_INCLUDE_DIR}
)

# g++ versions less than 9.1 need to link against libstdc++fs
# if std::filesystem is used
if(GCC AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.1)
    target_link_libraries(${lib} PRIVATE stdc++fs)
endif()
# the same applies to clang versions less than 9.0: they need to link
# against libstdc++fs or libc++fs if std::filesystem is used
if(CLANG AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.0)
    if(LINUX)
        target_link_libraries(${lib} PRIVATE stdc++fs)
    else()
        target_link_libraries(${lib} PRIVATE c++fs)
    endif()
endif()

if(WIN32)
    target_compile_definitions(${lib} PRIVATE -DBA_BASE_BUILD_DLL)
endif()

=== Device/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainDevice
############################################################################

set(component Device)
set(lib BornAgain${component})

# --- source and include files ---

file(GLOB source_files */*.cpp)
file(GLOB include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)

# --- define target properties ---
add_library(${lib} SHARED)
set_target_properties(${lib} PROPERTIES
    COMPONENT_NAME ${component}
    SWIG_TMP_DIR "${CMAKE_CURRENT_BINARY_DIR}/Wrap"
    SOURCE_FILES "${source_files}"
    INCLUDE_FILES "${include_files}"
    EMBED_PYTHON ${BORNAGAIN_PYTHON})

# --- make the library ---
MakeLib(${lib})

# --- external dependencies ---

target_link_libraries(${lib}
    PUBLIC
    BornAgainBase
    BornAgainFit
    BornAgainParam
    BornAgainSample
    BornAgainResample
    ${CMAKE_THREAD_LIBS_INIT}
    ${tspectrum_LIBRARY}
)
if(BORNAGAIN_PYTHON)
    target_link_libraries(${lib} PUBLIC BornAgainPyCore)
endif()

target_include_directories(${lib}
    PUBLIC
    ${CMAKE_SOURCE_DIR}
    SYSTEM PUBLIC
    ${tspectrum_INCLUDE_DIR}
    )

if(BA_TIFF_SUPPORT)
    target_link_libraries(${lib} PUBLIC ${TIFF_LIBRARIES})
    target_include_directories(${lib} PUBLIC ${TIFF_INCLUDE_DIR})
    target_compile_definitions(${lib} PUBLIC -DBA_TIFF_SUPPORT)
endif()

if(WIN32)
    target_compile_definitions(${lib} PRIVATE -DBA_DEVICE_BUILD_DLL)
endif()

=== Fit/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainFit
############################################################################

set(component Fit)
set(lib BornAgain${component})

# --- source and include files ---

file(GLOB source_files */*.cpp)
file(GLOB include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)

# --- define target properties ---
add_library(${lib} SHARED)
set_target_properties(${lib} PROPERTIES
    COMPONENT_NAME ${component}
    SWIG_TMP_DIR "${CMAKE_CURRENT_BINARY_DIR}/Wrap"
    SOURCE_FILES "${source_files}"
    INCLUDE_FILES "${include_files}"
    EMBED_PYTHON ${BORNAGAIN_PYTHON})

# --- make the library ---
MakeLib(${lib})

# --- external dependences ---

target_link_libraries(${lib}
    PUBLIC
    ${Boost_LIBRARIES}
    ${Boost_Additional_Libraries}
    PRIVATE
    ${RootMinimizers_LIBRARY}
    )
target_include_directories(${lib}
    PUBLIC
    ${CMAKE_SOURCE_DIR}
    SYSTEM PUBLIC # because needed by Fit/Test/Unit
    ${Boost_INCLUDE_DIRS}
    SYSTEM PRIVATE
    ${RootMinimizers_INCLUDE_DIRS}
    )

=== GUI/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building BornAgain/GUI libraries and executable
############################################################################

message(STATUS "Configuring BornAgain GUI")

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)

set(lib BornAgainGUI)

# --- source and include files ---

file(GLOB_RECURSE include_files View/Mask/ISceneAdaptor.h) # no clue why this is needed
file(GLOB_RECURSE source_files *.cpp)
file(GLOB_RECURSE forms_files *.ui)

set(resource_files
    gui.qrc
    View/SampleDesigner/SampleDesigner.qrc
    View/Mask/MaskWidgets.qrc
)

# --- Qt configuration ---------

qt_add_resources(RC_SRCS ${resource_files})

# --- definitions ------

if(BA_CRASHHANDLER)
    add_definitions(-DBA_CRASHHANDLER)
endif()

if(WIN32)
    string(APPEND CMAKE_CXX_FLAGS " -DBA_GUI_BUILD_DLL")
endif()

# --- make the library ---------

add_library(${lib} SHARED ${source_files} ${RC_SRCS} ${include_files} ${form_files})
#set_target_properties(${lib} PROPERTIES PREFIX ${libprefix} SUFFIX ${libsuffix})

get_target_property(lib_dir ${lib} LIBRARY_OUTPUT_DIRECTORY)
set(BornAgain_LIBRARIES "$CACHE{BornAgain_LIBRARIES};${lib_dir}/${libprefix}${lib}${libsuffix}"
    CACHE INTERNAL "BornAgain libraries")

# switch OFF Qt debug output in any configuration except DEBUG
target_compile_definitions(${lib} PUBLIC $<$<NOT:$<CONFIG:Debug>>:QT_NO_DEBUG_OUTPUT>)

if(BORNAGAIN_PYTHON)
    target_compile_definitions(${lib} PRIVATE -DBORNAGAIN_PYTHON)
endif()

# --- external dependences ---------

target_link_libraries(${lib}
    PUBLIC
    BornAgainSim
    BornAgainImg3D
    Qt6::Widgets
    Qt6::Core
    Qt6::Gui
    Qt6::OpenGLWidgets
    PRIVATE
    Qt6::PrintSupport
    qcustomplot
)
if(BORNAGAIN_PYTHON)
    target_link_libraries(${lib} PUBLIC BornAgainPyCore)
endif()
target_include_directories(${lib} PUBLIC
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/3rdparty/GUI/qcustomplot
)

# --- installation ---------

set_target_properties(${lib} PROPERTIES
    PREFIX ${libprefix}
    SUFFIX ${libsuffix}
    OUTPUT_NAME ${lib}
    )

install(TARGETS ${lib}
    LIBRARY DESTINATION ${destination_lib} COMPONENT Libraries
    RUNTIME DESTINATION ${destination_lib} COMPONENT Libraries)

=== Img3D/CMakeLists.txt ===
set(lib BornAgainImg3D)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)

file(GLOB_RECURSE source_files *.cpp)

set(CMAKE_AUTORCC ON)
qt_add_resources(RC_SHADERS shaders.qrc)

add_library(${lib} STATIC ${source_files} ${RC_SHADERS})
target_include_directories(${lib}
    PUBLIC
    ${CMAKE_SOURCE_DIR}
    SYSTEM PUBLIC
    ${LibHeinz_INCLUDE_DIR}
    ${formfactor_INCLUDE_DIR}
)

target_link_libraries(${lib} Qt6::Core Qt6::Widgets Qt6::OpenGL Qt6::OpenGLWidgets)

=== PyCore/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainPyCore
############################################################################

# NOTE: The module is directly dependent on Python and Numpy C-API
if(NOT BORNAGAIN_PYTHON)
    return()
endif()

set(component PyCore)
set(lib BornAgain${component})

# --- source and include files ---
# Python-dependent source files
file(GLOB_RECURSE source_files */*.cpp)
file(GLOB_RECURSE include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)

# --- define target properties ---
add_library(${lib} SHARED)
set_target_properties(${lib} PROPERTIES
    COMPONENT_NAME ${component}
    SWIG_TMP_DIR ""
    SOURCE_FILES "${source_files}"
    INCLUDE_FILES "${include_files}"
    EMBED_PYTHON ${BORNAGAIN_PYTHON})

# --- make the library ---
MakeLib(${lib})

target_include_directories(${lib}
    PRIVATE
    ${CMAKE_SOURCE_DIR}
    ${LibHeinz_INCLUDE_DIR}
    ${Python3_INCLUDE_DIRS}
    ${Python3_NumPy_INCLUDE_DIRS}
)

target_link_libraries(${lib}
    PUBLIC
    ${Python3_LIBRARIES}
)

=== Resample/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainResample
############################################################################

set(component Resample)
set(lib BornAgain${component})

# --- source and include files ---

file(GLOB source_files */*.cpp)
file(GLOB include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)

# --- define target properties ---
add_library(${lib} SHARED)
set_target_properties(${lib} PROPERTIES
    COMPONENT_NAME ${component}
    SWIG_TMP_DIR "${CMAKE_CURRENT_BINARY_DIR}/Wrap"
    SOURCE_FILES "${source_files}"
    INCLUDE_FILES "${include_files}"
    EMBED_PYTHON ${BORNAGAIN_PYTHON})

# --- make the library ---
MakeLib(${lib})

# --- external dependences ---

target_link_libraries(${lib}
    PUBLIC
    BornAgainSample
    )
target_include_directories(${lib}
    PUBLIC
    ${CMAKE_SOURCE_DIR}
    )

=== Sample/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainSample
############################################################################

set(component Sample)
set(lib BornAgain${component})

# --- source and include files ---

file(GLOB source_files */*.cpp)
file(GLOB include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)

# --- define target properties ---
add_library(${lib} SHARED)
set_target_properties(${lib} PROPERTIES
    COMPONENT_NAME ${component}
    SWIG_TMP_DIR "${CMAKE_CURRENT_BINARY_DIR}/Wrap"
    SOURCE_FILES "${source_files}"
    INCLUDE_FILES "${include_files}"
    EMBED_PYTHON ${BORNAGAIN_PYTHON})

# --- make the library ---
MakeLib(${lib})

# --- external dependences ---

target_link_libraries(${lib}
    PUBLIC
    BornAgainParam
    formfactor
    )
target_include_directories(${lib}
    PUBLIC
    ${CMAKE_SOURCE_DIR}
    ${formfactor_INCLUDE_DIR}
    )

=== Sim/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainSim
############################################################################

set(component Sim)
set(lib BornAgain${component})

# --- source and include files ---

file(GLOB source_files */*.cpp)
file(GLOB include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)

# --- define target properties ---
add_library(${lib} SHARED)
set_target_properties(${lib} PROPERTIES
    COMPONENT_NAME ${component}
    SWIG_TMP_DIR "${CMAKE_CURRENT_BINARY_DIR}/Wrap"
    SOURCE_FILES "${source_files}"
    INCLUDE_FILES "${include_files}"
    EMBED_PYTHON ${BORNAGAIN_PYTHON})
if(BATCH_MODE)
    target_compile_definitions(${lib} PRIVATE SILENT_PROGRESS=ON)
endif()

# --- make the library ---
MakeLib(${lib})

# --- external dependences ---

target_link_libraries(${lib}
    PUBLIC
    BornAgainSample
    BornAgainDevice
    PRIVATE
    BornAgainResample
    ${CMAKE_THREAD_LIBS_INIT}
    ${cerf_target})

target_include_directories(${lib}
    PUBLIC
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/3rdparty/Core/ # needed for cerfcpp header
    )

=== Doc/Doxygen/CMakeLists.txt ===
# configure Doxyfiles; define targets doxy and doxy${section}
find_package(Doxygen REQUIRED)
set(AUTO_DOX_DIR ${CMAKE_BINARY_DIR}/doxygen)
file(MAKE_DIRECTORY ${AUTO_DOX_DIR})
file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/html)
add_custom_target(doxy) # this target builds _all_ documentation sections
foreach(section core gui)
    configure_file(${section}/Doxyfile.in
        ${AUTO_DOX_DIR}/Doxyfile.${section} @ONLY)
    add_custom_target(doxy${section}
        COMMAND Doxygen::doxygen ${AUTO_DOX_DIR}/Doxyfile.${section} )
    add_dependencies(doxy doxy${section})
endforeach()

=== debian/changelog ===
bornagain (21.1+ds3-4) unstable; urgency=medium

  * Bug fix: "Please drop dependencies on python3-distutils", thanks to
    Graham Inggs (Closes: #1065835).

 -- Roland Mas <lolando@debian.org>  Thu, 21 Mar 2024 22:38:28 +0100

bornagain (21.1+ds3-3) unstable; urgency=medium

  * Link against Swig 4.2; this fixes: "FTBFS: make[1]: ***
    [debian/rules:41: override_dh_auto_configure] Error 2", thanks to
    Lucas Nussbaum (Closes: #1064750).
  * For some reason, this also fixes: "ftbfs with LTO (link time
    optimization) enabled", thanks to Matthias Klose (Closes: #1015364).

 -- Roland Mas <lolando@debian.org>  Wed, 28 Feb 2024 18:29:19 +0100

bornagain (21.1+ds3-2) unstable; urgency=medium

  * d/rules: fix FTBFS on arch all
  * d/rules: use the current cmake options
  * split the arch/indep install target

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Thu, 14 Dec 2023 16:58:21 +0100

bornagain (21.1+ds3-1) unstable; urgency=medium

  * d/control: Added B-D libcerf-dev (>= 2.3)
  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Build-Depends: s/dh-python/dh-sequence-python3/ (routine-update)
  * Rules-Requires-Root: no (routine-update)

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Wed, 13 Dec 2023 09:23:08 +0100

=== debian/control ===
Source: bornagain
Maintainer: Debian PaN Maintainers <debian-pan-maintainers@alioth-lists.debian.net>
Uploaders:
 Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>,
 Mika Pflüger <debian@mikapflueger.de>,
 Freexian Packaging Team <team+freexian@tracker.debian.org>,
 Picca Frédéric-Emmanuel <picca@debian.org>,
 Roland Mas <lolando@debian.org>,
Section: science
Priority: optional
Build-Depends: clang-format <!nocheck>,
               cmake,
               debhelper-compat (= 13),
               dh-sequence-python3,
               doxygen-latex <!nodoc>,
               libboost-all-dev,
               libcerf-dev (>= 2.3),
               libeigen3-dev,
               libformfactor-dev,
               libfftw3-dev,
               libgsl0-dev,
               libheinz-dev,
               libqt6opengl6-dev,
               libtiff-dev,
               libxkbcommon-dev,
               libyaml-cpp-dev,
               python3-dev <!nopython>,
               python3-matplotlib <!nopython>,
               python3-numpy <!nopython>,
               python3-pip <!nopython>,
               python3-yaml <!nopython>,
               qt6-base-dev,
               qt6-svg-dev,
               swig <!nopython>,
Build-Depends-Indep:
               hugo <!nodoc>,
               texlive-fonts-extra <!nodoc>,
               texlive-xetex <!nodoc>,
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/science-team/bornagain
Vcs-Git: https://salsa.debian.org/science-team/bornagain.git
Homepage: https://bornagainproject.org/
Rules-Requires-Root: no

Package: bornagain
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: python3-bornagain
Description: Simulate and fit X-ray and neutron GISAS -- binary
 BornAgain is a software package to simulate and fit small-angle scattering at
 grazing incidence. It supports analysis of both X-ray (GISAXS) and neutron
 (GISANS) data. Calculations are carried out in the framework of the distorted
 wave Born approximation (DWBA). BornAgain provides a graphical user interface
 for interactive use as well as a generic Python and C++ framework for modeling
 multilayer samples with smooth or rough interfaces and with various types of
 embedded nanoparticles.
 .
 BornAgain supports:
 .
 Layers:
  * Multilayers without any restrictions on the number of layers
  * Interface roughness correlation
  * Magnetic materials
 .
 Particles:
  * Choice between different shapes of particles (form factors)
  * Particles with inner structures
  * Assemblies of particles
  * Size distribution of the particles (polydispersity)
 .
 Positions of Particles:
  * Decoupled implementations between vertical and planar positions
  * Vertical distributions: particles at specific depth in layers or on top.
  * Planar distributions:
    - fully disordered systems
    - short-range order distribution (paracrystals)
    - two- and one-dimensional lattices
 .
 Input Beam:
  * Polarized or unpolarized neutrons
  * X-ray
  * Divergence of the input beam (wavelength, incident angles) following
    different distributions
  * Possible normalization of the input intensity
 .
 Detector:
  * Off specular scattering
  * Two-dimensional intensity matrix, function of the output angles
 .
 Use of BornAgain:
  * Simulation of GISAXS and GISANS from the generated sample
  * Fitting to reference data (experimental or numerical)
  * Interactions via Python scripts or Graphical User Interface
 .
 If you use BornAgain in your work, please cite
  C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke (2015), BornAgain
  — Software for simulating and fitting X-ray and neutron small-angle
  scattering at grazing incidence, version <version you used>,
  http://www.bornagainproject.org

Package: python3-bornagain
Architecture: any
Depends: python3-matplotlib,
         python3-numpy,
         python3-yaml,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: Simulate and fit X-ray and neutron GISAS -- Python3
 BornAgain is a software package to simulate and fit small-angle scattering at
 grazing incidence. It supports analysis of both X-ray (GISAXS) and neutron
 (GISANS) data. Calculations are carried out in the framework of the distorted
 wave Born approximation (DWBA). BornAgain provides a graphical user interface
 for interactive use as well as a generic Python and C++ framework for modeling
 multilayer samples with smooth or rough interfaces and with various types of
 embedded nanoparticles.
 .
 BornAgain supports:
 .
 Layers:
  * Multilayers without any restrictions on the number of layers
  * Interface roughness correlation
  * Magnetic materials
 .
 Particles:
  * Choice between different shapes of particles (form factors)
  * Particles with inner structures
  * Assemblies of particles
  * Size distribution of the particles (polydispersity)
 .
 Positions of Particles:
  * Decoupled implementations between vertical and planar positions
  * Vertical distributions: particles at specific depth in layers or on top.
  * Planar distributions:
    - fully disordered systems
    - short-range order distribution (paracrystals)
    - two- and one-dimensional lattices
 .
 Input Beam:
  * Polarized or unpolarized neutrons
  * X-ray
  * Divergence of the input beam (wavelength, incident angles) following
    different distributions
  * Possible normalization of the input intensity
 .
 Detector:
  * Off specular scattering
  * Two-dimensional intensity matrix, function of the output angles
 .
 Use of BornAgain:
  * Simulation of GISAXS and GISANS from the generated sample
  * Fitting to reference data (experimental or numerical)
  * Interactions via Python scripts or Graphical User Interface
 .
 If you use BornAgain in your work, please cite
  C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke (2015), BornAgain
  — Software for simulating and fitting X-ray and neutron small-angle
  scattering at grazing incidence, version <version you used>,
  http://www.bornagainproject.org
 .
  This package contains the Python bindings for use in scripts.

Package: bornagain-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}, ${shlibs:Depends}, libjs-bootstrap,
 libjs-jquery, libjs-popper.js, fonts-open-sans, fonts-roboto, fonts-font-awesome
Recommends: bornagain
Multi-Arch: foreign
Description: Simulate and fit X-ray and neutron GISAS -- doc
 BornAgain is a software package to simulate and fit small-angle scattering at
 grazing incidence. It supports analysis of both X-ray (GISAXS) and neutron
 (GISANS) data. Calculations are carried out in the framework of the distorted
 wave Born approximation (DWBA). BornAgain provides a graphical user interface
 for interactive use as well as a generic Python and C++ framework for modeling
 multilayer samples with smooth or rough interfaces and with various types of
 embedded nanoparticles.
 .
 BornAgain supports:
 .
 Layers:
  * Multilayers without any restrictions on the number of layers
  * Interface roughness correlation
  * Magnetic materials
 .
 Particles:
  * Choice between different shapes of particles (form factors)
  * Particles with inner structures
  * Assemblies of particles
  * Size distribution of the particles (polydispersity)
 .
 Positions of Particles:
  * Decoupled implementations between vertical and planar positions
  * Vertical distributions: particles at specific depth in layers or on top.
  * Planar distributions:
    - fully disordered systems
    - short-range order distribution (paracrystals)
    - two- and one-dimensional lattices
 .
 Input Beam:
  * Polarized or unpolarized neutrons
  * X-ray
  * Divergence of the input beam (wavelength, incident angles) following
    different distributions
  * Possible normalization of the input intensity
 .
 Detector:
  * Off specular scattering
  * Two-dimensional intensity matrix, function of the output angles
 .
 Use of BornAgain:
  * Simulation of GISAXS and GISANS from the generated sample
  * Fitting to reference data (experimental or numerical)
  * Interactions via Python scripts or Graphical User Interface
 .
 If you use BornAgain in your work, please cite
  C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke (2015), BornAgain
  — Software for simulating and fitting X-ray and neutron small-angle
  scattering at grazing incidence, version <version you used>,
  http://www.bornagainproject.org
 .
  This package contains the BornAgain documentation.

=== debian/rules ===
#!/usr/bin/make -f
# output every command that modifies files on the build system.
export DH_VERBOSE = 1

# deal with profiles
CONFIG_SWITCHES=-DCMAKE_DEB_HOST_MULTIARCH=$(DEB_HOST_MULTIARCH)

ifneq ($(filter nodoc,$(DEB_BUILD_PROFILES)),)
	CONFIG_SWITCHES += -DCONFIGURE_DOXY=OFF
else
	CONFIG_SWITCHES += -DCONFIGURE_DOXY=ON
endif

ifneq ($(filter nopython,$(DEB_BUILD_PROFILES)),)
	CONFIG_SWITCHES += -DBORNAGAIN_PYTHON=OFF -DCONFIGURE_BINDINGS=OFF
else
	CONFIG_SWITCHES += -DBORNAGAIN_PYTHON=ON -DCONFIGURE_BINDINGS=ON
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

export CMAKE_OPTIONS := \
  -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
  -DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
  -DCMAKE_PREFIX_PATH="/usr/share/cmake/heinz;/usr/share/cmake/formfactor" \
  -DCMAKE_LIBRARY_PATH=/usr/lib/$(DEB_HOST_MULTIARCH)/bornagain \
  -DCMAKE_BUILD_TYPE=Release

%:
	dh $@

execute_after_dh_clean:
	rm -rf hugo/public hugo/.hugo_build.lock
	find auto -name *.pyc -delete

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_OPTIONS) $(CONFIG_SWITCHES) -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

override_dh_auto_build-arch:
	dh_auto_build

override_dh_auto_build-indep:
	dh_auto_build
	cd hugo && hugo

execute_after_dh_auto_install:
	find debian/tmp -name __pycache__ | xargs -r rm -r
	rm -f debian/tmp/usr/share/Bornagain/bornagain_build.log

override_dh_install-arch:
	#  bornagain
	dh_install -p bornagain usr/bin/bornagain
	dh_install -p bornagain usr/lib/*/bornagain/_libBornAgainGUI.so
	dh_install -p bornagain usr/share/BornAgain/Images/* usr/share/bornagain/images/
	dh_install -p bornagain usr/share/man/

	# python3-bornagain
	dh_install -p python3-bornagain -X_libBornAgainGUI.so usr/lib/*/bornagain/*.so
	dh_install -p python3-bornagain usr/lib/python3/*

override_dh_install-indep:
	# bornagain-doc
	dh_install -p bornagain-doc usr/share/BornAgain/Examples/* usr/share/doc/bornagain/examples/
	dh_install -p bornagain-doc hugo/public/* usr/share/doc/bornagain/html

execute_before_dh_missing-arch:
	# rm remaining files (workaround FTBFS...)
	rm -rf debian/tmp/usr/share

execute_before_dh_missing-indep:
	# rm remaining files (workaround FTBFS...)
	rm  -f debian/tmp/usr/bin/bornagain
	rm -rf debian/tmp/usr/lib
	rm -rf debian/tmp/usr/share/BornAgain/
	rm -f  debian/tmp/usr/share/man/man1/bornagain.1

=== debian/tests/control ===
# tests that must pass

Tests: python3
Depends:
 python3-all,
 python3-bornagain,
Restrictions: allow-stderr, skip-not-installable

=== debian/watch ===
version=4
opts=\
dversionmangle=auto,\
repacksuffix=+ds3,\
repack,\
filenamemangle=s/.*?(\d[\d\.]*@ARCHIVE_EXT@)/@PACKAGE@-$1/ \
https://jugit.fz-juelich.de/mlz/bornagain/tags?sort=updated_desc .*/v?@ANY_VERSION@/.*@ARCHIVE_EXT@
